/* Mailforward wird suid root irgendwo hingelegt und kann dann z.B. vom
 * Webserver aus als CGI aufgerufen werden, damit dieses dann Forwardfiles
 * fr die User anlegt oder lscht. Bestehende Forwards werden bercksichtigt!
 *
 * This file is part of mailforward.
 *
 * Mailforward is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Mailforward is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * or get it at http://www.gnu.org/licenses/gpl.html
 *
 * $Id: mailforward.c,v 1.4 2003/08/29 21:08:53 poc Exp poc $
 *
 * $Log: mailforward.c,v $
 * Revision 1.4  2003/08/29 21:08:53  poc
 * GPL-Info ergnzt
 *
 * Revision 1.3  2000/09/13 09:23:19  poc
 * ERRNO selbst setzen raus: libc5 kannte einige Konstanten (ENOTSUP) nicht.
 *
 * Revision 1.2  2000/09/05 10:07:15  poc
 * berflssige Funktion round2bound() rausgeworfen
 * chmod ergnzt, damit die .forward mode 600
 *
 * Revision 1.1  2000/09/01 13:59:55  poc
 * Abfrage auf leeren Aliasparameter nach + und - ergnzt.
 *
 * Revision 1.0  2000/09/01 13:27:27  poc
 * Erste fertige Version
 * chown fr neue Files eingebaut
 *
 * Revision 0.5  2000/09/01 12:48:37  poc
 * Soweit fertig
 * Lschen von 0-Byte Forwardfiles eingebaut
 * Forward-Schreiben eingebaut
 *
 * Revision 0.4  2000/09/01 08:54:59  poc
 * Globaler Buffer in Struct eingefgt
 * Alias hinzufgen okay
 * Diverse Aufrumarbeiten
 *
 * Revision 0.3  2000/08/31 14:40:04  poc
 * Diverse Funktionen ergnzt
 * Codebereingung
 * Buffer-Rewriter vorbereitet
 *
 * Revision 0.2  2000/08/31 11:43:02  poc
 * printbuf() fertiggestellt
 * Spaces werden nun nicht mehr als Feldtrenner gesehen
 *
 * Revision 0.1  2000/08/31 11:09:03  poc
 * Parseforward fertiggestellt (Nullbyteparsing)
 * Kommentare ergnzt
 *
 */

#include <stdio.h>
#include <string.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>


/* Verschiedene Defines, change as needed */
#define FORWARDFILE ".forward"
#define FSBLOCKSIZE 512
#define MAXFWDENTRIES 64


/* Fr die Informationen, die wir bentigen */
struct userinfo {
	char	*u_name;	/* Username */
	uid_t	uid;		/* User-ID */
	gid_t	gid;		/* Primre Gruppe */
	char	*u_home;	/* HomeDir */
	char 	*u_fwd;		/* Pfad zum Forwardfile */
	int 	forward;	/* Gibt's das Phile oder net (0 = OK) */
	size_t	fw_size;	/* Bytes des Forwardfile auf Blocks aufgerundet */
};

struct bufstruct {
	char	*filebuf;	/* Globaler Bffa fr das Forwardfile */
	char	*bufarray[MAXFWDENTRIES];
	int		arraysize;	/* Wieviele Eintrge das Array hat */
	int		delthis;	/* Welches Element soll gelscht werden */
};

struct bufstruct gbuf;



/* Raus hier aber mit Erklrung */
void bail_out_with_help(void) {
		printf("Aufruf:\t<login> +mail@adresse.wo (Hinzufuegen)\n\t<login> -mail@adresse.wo (Herausnehmen)\n\t<login> (Anzeigen)\n\n");
	    exit(1);
}



/* fill_uinfo() holt sich die verschiedenen Infos ber den User aus verschiedenen Quellen */
int fill_uinfo(char *login, struct userinfo *uinfo) {
	struct passwd	*pw;
	int				retval;
	struct stat		statbuf;

	if ( login != NULL ) {
		pw = getpwnam(login);
		endpwent();

	    if ( pw == NULL ) { /* Schiefgegangen */
			fprintf(stderr, "Benutzer %s unbekannt.\n", login);
			retval = -1;
	    } else {	/* Wenn das getpwnam geklappt hat */
			/* Okay, dann den Struct ausfllen */
			uinfo->u_name = pw->pw_gecos;
			uinfo->u_home = pw->pw_dir;
			uinfo->uid = pw->pw_uid;
			uinfo->gid = pw->pw_gid;
			
			if ( (uinfo->u_fwd = malloc(strlen(uinfo->u_home) + 16)) ) {
				strcpy(uinfo->u_fwd, uinfo->u_home);
				strcat(uinfo->u_fwd, "/");
				strcat(uinfo->u_fwd, FORWARDFILE);
				/* So, Pfad hamma inkl. dem forwardfile, jetzt schaun was geht */
				uinfo->forward = stat(uinfo->u_fwd, &statbuf);
				if ( uinfo->forward == 0 ) {
					uinfo->fw_size = statbuf.st_blocks * FSBLOCKSIZE;
				} else {
					#ifdef DEBUG
					fprintf(stderr, "Kein Forwardfile gefunden.\n");
					#endif
				}
			} else {	/* Malloc fr den Pfad failed */
				#ifdef DEBUG
				fprintf(stderr, "malloc() fr den Forwardpfad schlug fehl.\n");
				#endif
				retval = -1;
			}
			retval = uinfo->forward;
	    }
	} else {	/* Wenn der bergebene Login jetzt nun doch NULL ist */
		#ifdef DEBUG
		fprintf(stderr, "validate_login(): NULL kann ich nicht finden.\n");
		#endif
		retval = -1;
	}
	return(retval);
}



/* parseforward() schraubt das Forwardfile auseinander und schmeit die einzelnen Bestandteile in ein globales Array */
int parseforward(struct userinfo *uinfo) {
	int				retval = 0, fd, j = 0, i = 0, bufptr = 0;

	fd = open(uinfo->u_fwd, O_RDONLY);
	if ( fd >= 0 ) {
		retval = read(fd, gbuf.filebuf, uinfo->fw_size);
		if ( retval != -1 ) {
			/* Alle Feldtrenner erstmal durch 0 initialisieren */
			for ( i = 0; i < uinfo->fw_size; i++ ) {
				if ( gbuf.filebuf[i] == '\n' || gbuf.filebuf[i] == ',' ) {
					gbuf.filebuf[i] = 0;
				}
			}
			/* So, und jetzt verpointern wir den Kram auf bufarray */
			for ( i = 0; i < uinfo->fw_size; i++ ) {
				if ( gbuf.filebuf[i] == 0 ) {
					if ( gbuf.filebuf[i-1] != 0 ) {
						gbuf.bufarray[bufptr] = &gbuf.filebuf[j];
						bufptr++;
						if ( bufptr > MAXFWDENTRIES ) {
							fprintf(stderr, "Zuviele Forwardadressen gefunden. Bitte Define im Quellcode aendern und neu kompilieren.\n");
							exit(1);
						}
					}
					j = i + 1;
				}
			}
			gbuf.arraysize = bufptr;
		} else {	/* Wenn der Lesevorgang schief gegangen ist... */
			perror("read() failed");
		}
		close(fd);
	} else {
		perror("Fehler beim ffnen der Forwarddatei");
		retval = -1;
	}
	return(retval);
}



/* printbuf() gibt den Forwardbuffer aus */
int printbuf(void) {
	int				i;

	for  ( i = 0; i < gbuf.arraysize; i++ ) {
		if ( gbuf.delthis!= i ) {
			printf("%s\n", gbuf.bufarray[i]);
		}
	}
	return(0);
}



/* Buffer anhand des Kommandos ndern */
int rewrite_buf(struct userinfo *uinfo, char *string) {
	int				i = 0, retval = 0;
	char			was, *alias;

	was = string[0];
	alias = ++string;

	if ( strlen(alias) == 0 ) {
		bail_out_with_help();
		exit(1);
	}

	switch(was) {
		case '+': {
			gbuf.bufarray[gbuf.arraysize] = alias;
			gbuf.arraysize++;
			break;
		}
		case '-': {
			for  ( i = 0; i < gbuf.arraysize; i++ ) {
	        	if ( (strcasecmp(alias, gbuf.bufarray[i]) == 0) )
				#ifdef DEBUG
				printf("Match: %s bei %d\n", alias, i);
				#endif
				gbuf.delthis = i;
			}
			break;
		}
		default:  {
			bail_out_with_help();
			break;
		}
	}
	return(retval);
}



/* Forwardfile aus Buffer erzeugen und schreiben */
int write_forward(struct userinfo *uinfo) {
	int				retval = 0, i;
	FILE			*fd;
	struct stat		statbuf;

	fd = fopen(uinfo->u_fwd, "w+");
	if ( fd != NULL ) {
		for  ( i = 0; i < gbuf.arraysize; i++ ) {
			if ( gbuf.delthis!= i ) {
				fprintf(fd, "%s\n", gbuf.bufarray[i]);
			}
		}
		fclose(fd);
		retval = (chown(uinfo->u_fwd, uinfo->uid ,uinfo->gid)) + retval;
		retval = (stat(uinfo->u_fwd, &statbuf)) + retval;
		retval = (chmod(uinfo->u_fwd, 0600)) + retval;
		if ( statbuf.st_size == 0 ) retval = (unlink(uinfo->u_fwd) + retval);
	} else {
		retval = -1;
	}
	return(retval);
}



int main(int argc, char *argv[]) {
	struct userinfo	uinfo;
	int				error = 0, retval = 0;

	gbuf.delthis = -1;

	/*
	 * Erstmal die Kommandozeile auseinanderbrseln
	 * argv[0] sind wir
	 * argv[1] ist der zu bearbeitende Login
	 * argv[2] ist das, was mit dem Login zu machen ist und und Parameter dazu
	 *
	 */

	if ( argc == 3 || argc == 2 ) {

		/* Infos zum Login zusammensammeln */
		if ( fill_uinfo(argv[1], &uinfo) == 0 ) {
			/* So, jetzt den Bffer fr das Forwardfile initialisieren... */
			gbuf.filebuf = malloc(uinfo.fw_size);
			if ( gbuf.filebuf == NULL ) {
				fprintf(stderr, "malloc() fuer den Arbeitspuffer schlug fehl.\n");
				exit(1);
			} else {
				memset(gbuf.filebuf, 0x0, uinfo.fw_size);
				parseforward(&uinfo);
			}
		}

		/* Jetzt mal sehen, was wir berhaupt machen mssen */
		if ( argc == 2 && gbuf.arraysize > 0 ) {
			printbuf();
		} else if ( argc == 3 ) {
			error=rewrite_buf(&uinfo, argv[2]);
			if ( error == 0 ) {
				if ( write_forward(&uinfo) != 0 ) fprintf(stderr, "Fehler beim Schreiben des Forwardfiles.\n");
			} else {
				fprintf(stderr, "rewrite_buf() schlug fehl.\n");
				exit(1);
			}
		}
		free(gbuf.filebuf);
	    retval = 0;
	} else {
		bail_out_with_help();
	}
	return(retval);
}

